using System;
using System.Windows.Forms;
using System.Collections;
using System.Reflection;
using System.Globalization;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Security;
using System.Security.Permissions;
using System.Data;

using Syncfusion.Windows.Forms;
using Syncfusion.Styles;
using Syncfusion.Diagnostics;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;
using System.Drawing;
namespace GES.GridCellModels
{
	/// <summary>
	/// Summary description for GesTextBoxCell.
	/// </summary>
	public class GesTextBoxCellModel : GridTextBoxCellModel 
	{
		public GesTextBoxCellModel(GridModel grid):base(grid)
		{}
		
		/// <summary>
		/// Initializes a new <see cref="GridTextBoxCellModel"/> from a serialization stream.
		/// </summary>
		/// <param name="info">An object that holds all the data needed to serialize or deserialize this instance.</param>
		/// <param name="context">Describes the source and destination of the serialized stream specified by info. </param>
		protected GesTextBoxCellModel(SerializationInfo info, StreamingContext context): base(info, context)
		{}

		/// <summary>
		/// Overridden to return a GesGridFormulaCellRenderer class.
		/// </summary>
		/// <param name="control">The grid.</param>
		/// <returns>A GesGridFormulaCellRenderer object.</returns>
		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new GesTextBoxCellRenderer(control, this);
		}

//		protected override Size OnQueryPrefferedClientSize(Graphics g, int rowIndex, int colIndex, GridStyleInfo style, GridQueryBounds queryBounds)
//		{
//			//don't size col width...
//			//  'in versions >= 2.0.6.0, use WinFormsUtils.MeasureSampleWString instead of GridCellModelBase.MeasureSampleWString
//			//Size clientSize = new Size(this.Grid.ColWidths[colIndex], WinFormsUtils.MeasureSampleWString(g, style.GdipFont).Height);
//			return new Size(this.Grid.ColWidths[colIndex], this.Grid.RowHeights[rowIndex]);
//		}
	}

	public class GesTextBoxCellRenderer : GridTextBoxCellRenderer
	{
		
		/// <summary>
		/// Initializes a new GesIntegerCellRenderer object for the given GridControlBase
		/// and GridCellModelBase.
		/// </summary>
		/// <param name="grid">The <see cref="GridControlBase"/> that displays this cell renderer.</param>
		/// <param name="cellModel">The <see cref="GridCellModelBase"/> that holds data for this cell renderer that should
		/// be shared among views.</param>
		/// <remarks>References to GridControlBase, 
		/// and GridCellModelBase will be saved.</remarks>
		public GesTextBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel): base(grid, cellModel)
		{}

		
		protected override void OnClick(int rowIndex, int colIndex, MouseEventArgs e)
		{
			//base.OnClick (rowIndex, colIndex, e);
		}

		protected override void OnDoubleClick(int rowIndex, int colIndex, MouseEventArgs e)
		{
			//base.OnDoubleClick (rowIndex, colIndex, e);
		}

		protected override void OnKeyDown(KeyEventArgs e)
		{
						
			if (!e.Handled && e.KeyCode == Keys.Return && CurrentCell.IsEditing)
			{

				CurrentCell.ConfirmChanges();
				CurrentCell.EndEdit();
				//CurrentCell.MoveTo(RowIndex,ColIndex,GridSetCurrentCellOptions.BeginEndUpdate);
				CurrentCell.SetCurrentCellNoActivate(RowIndex,ColIndex); 
				e.Handled = true;
			}
		
			if(!e.Handled)
				base.OnKeyDown (e);
			
		}
	}
}
